"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const EfficientnetModel_1 = require("./EfficientnetModel");
const EfficientNetCheckPoint_1 = require("./EfficientNetCheckPoint");
class EfficientNetCheckPointFactory {
    static create(checkPoint) {
        return __awaiter(this, void 0, void 0, function* () {
            switch (checkPoint) {
                case EfficientNetCheckPoint_1.EfficientNetCheckPoint.B0: {
                    const modelPath = "https://raw.githubusercontent.com/ntedgi/efficientnet/main/lib/tfjs/web_model/model.json";
                    const model = new EfficientnetModel_1.default(modelPath, 244);
                    yield model.load();
                    return model;
                }
                default: {
                    throw Error(`${checkPoint} - Not Implemented Yet!`);
                }
            }
        });
    }
}
exports.default = EfficientNetCheckPointFactory;
